"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isAbsoluteUrl = _interopRequireDefault(require("@lskjs/utils/isAbsoluteUrl"));

var _isMiddleClickEvent = _interopRequireDefault(require("@lskjs/utils/isMiddleClickEvent"));

var _isModifiedEvent = _interopRequireDefault(require("@lskjs/utils/isModifiedEvent"));

var _isLeftClickEvent = _interopRequireDefault(require("@lskjs/utils/isLeftClickEvent"));

var _composeUrl = _interopRequireDefault(require("@lskjs/utils/composeUrl"));

var _Link = _interopRequireDefault(require("./Link.context"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var getUapp = function getUapp() {
  if (typeof window !== 'undefined') {
    return window.app && window.app.uapp;
  }

  return null;
};

var Link = function Link(_ref) {
  var _ref$componentClass = _ref.componentClass,
      Component = _ref$componentClass === void 0 ? 'a' : _ref$componentClass,
      to = _ref.to,
      href = _ref.href,
      qs = _ref.qs,
      target = _ref.target,
      children = _ref.children,
      onClick = _ref.onClick,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["componentClass", "to", "href", "qs", "target", "children", "onClick"]);
  var ctx = (0, _react.useContext)(_Link["default"]);
  var url = (0, _composeUrl["default"])({
    url: to || href,
    qs: qs
  });

  var handleClick = function handleClick(e) {
    if (onClick) onClick(e);
    if ((0, _isMiddleClickEvent["default"])(e)) return;
    if (e.defaultPrevented === true) return;
    if ((0, _isModifiedEvent["default"])(e) || !(0, _isLeftClickEvent["default"])(e)) return;
    if (url == null) return;
    if (target === '_blank' || (0, _isAbsoluteUrl["default"])(url)) return;
    e.preventDefault();

    if (ctx && ctx.onClick) {
      ctx.onClick(url, e);
    } else if (getUapp() && getUapp().redirect) {
      if (__DEV__) console.debug('Link without LinkProvider: using global.app.uapp.history'); // eslint-disable-line no-console

      getUapp().redirect(url);
    } else {
      console.error('Link without LinkProvider (history)'); // eslint-disable-line no-console

      window.location = url;
    }
  };

  return /*#__PURE__*/_react["default"].createElement(Component, (0, _extends2["default"])({
    href: url,
    onClick: handleClick,
    target: target
  }, props), children);
};

Link.propTypes = {
  href: _propTypes["default"].string,
  children: _propTypes["default"].node,
  onClick: _propTypes["default"].func,
  target: _propTypes["default"].string,
  to: _propTypes["default"].string,
  qs: _propTypes["default"].objectOf(Object)
};
Link.defaultProps = {
  children: null,
  onClick: null,
  target: null,
  href: null,
  to: null,
  qs: {}
};
var _default = Link;
exports["default"] = _default;
//# sourceMappingURL=Link.js.map